import java.math.BigInteger;
import java.rmi.Naming;
import java.security.AlgorithmParameterGenerator;
import java.security.AlgorithmParameters;
import java.util.Random;

import javax.crypto.spec.DHParameterSpec;

public class RMIdhClient {
	public static void main(String[] args) {
		String serverName;
		if (args.length == 0) {
			serverName = "localhost";
		} else {
			serverName = args[0];
		}
		String rmiName = "rmi://" + serverName + ":80/RMIdhService";
		try {
			RMIdhInterface dh = (RMIdhInterface) Naming.lookup(rmiName);
			AlgorithmParameterGenerator paramGen = AlgorithmParameterGenerator.getInstance("DH");
			paramGen.init(512);
			AlgorithmParameters params = paramGen.generateParameters();
			DHParameterSpec dhSpec = (DHParameterSpec) params.getParameterSpec(DHParameterSpec.class);
			DhKey key = new DhKey();
			key.setG(dhSpec.getG());
			key.setP(dhSpec.getP());
			BigInteger secretA = new BigInteger(256, new Random());
			key.setPublicA(key.getG().modPow(secretA, key.getP()));
			key = dh.exchangeKeys(key);
			BigInteger secretKey = key.getPublicB().modPow(secretA, key.getP());
			System.out.println("kluc:"+secretKey);

		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
