import java.math.BigInteger;
import java.rmi.Naming;
import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.util.Random;

public class RMIdhServer {

	public RMIdhServer() {
		BigInteger secretB = new BigInteger(256, new Random());
		if (System.getSecurityManager() == null) {
			System.setSecurityManager(new RMISecurityManager());
		}
		try {
			LocateRegistry.createRegistry(80);
			RMIdhInterface dh = new RMIdhImpl(secretB);
			Naming.rebind("rmi://127.0.0.1:80/RMIdhService",dh);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String args[]){
		new RMIdhServer();
	}
	
}
